//
// $Id: asismp.dcl,v 1.6 1995/12/20 03:49:49 kirila Exp $
//
//    asismp.dcl
//    
//    Copyright (C) 1995, 1996 by Autodesk, Inc.
//    
//    Permission to use, copy, modify, and distribute this software 
//    for any purpose and without fee is hereby granted, provided
//    that the above copyright notice appears in all copies and 
//    that both that copyright notice and the limited warranty and 
//    restricted rights notice below appear in all supporting 
//    documentation.
//    
//    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.  
//    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
//    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
//    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
//    UNINTERRUPTED OR ERROR FREE.
//    
//    Use, duplication, or disclosure by the U.S. Government is subject to 
//    restrictions set forth in FAR 52.227-19 (Commercial Computer 
//    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
//    (Rights in Technical Data and Computer Software), as applicable. 
//
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//
//	AutoCAD ASI SAMPLES dialog file
//
//
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//
//================================================================
//
//	TOPIC CHOICE DIALOG BOX
//
//================================================================
conn_button : button {
	key		= "ID_BUTT_CONN";
	label		= "&CONNECT...";
	fixed_width	= true;
	width		= 15;
}
sqled_button : button {
	key		= "ID_BUTT_SQLED";
	label		= "&SQLEDIT...";
	fixed_width	= true;
	width		= 15;
}
disconn_button : button {
	key		= "ID_BUTT_DISCONN";
	label		= "&DISCONN...";
	fixed_width	= true;
	width		= 15;
}
asidiag_button : button {
	key		= "ID_BUTT_ASIDIAG";
	label		= "D&IAG...";
	fixed_width	= true;
	width		= 15;
}
exit_button : cancel_button {
	key 	= "cancel";
	label	= "E&XIT";
	fixed_width	= true;
	width		= 15;
}
choice_result : text {
	key = "ID_CHOICE_RESULT" ;
        alignment      = left ;
}
//
//	The main dialog for selecting topics
//
choice_dialog : dialog {
label = "ASI AutoLISP Samples";
: boxed_column {
	label = "Press button to run Sample:";
	:row {
		conn_button ;
		: text {label = "Connection with environment";}
		fixed_width	= true;
	}
	:row {
		sqled_button ;
		: text {label = "Execute SQL Sample";}
		fixed_width	= true;
	}
	:row {
		disconn_button ;
		: text {label = "Disconnection from environment";}
		fixed_width	= true;
	}
	:row {
		asidiag_button ;
		: text {label = "ASILISP diagnostics";}
		fixed_width	= true;
	}
	:row {
		exit_button ;
		: text {label = "Exit from SQL Samples";}
		fixed_width	= true;
	}
	choice_result ;
}}
//================================================================
//
//	SELECT ENVIRONMENT DIALOG BOX
//
//================================================================
envs_listbox : list_box {
	key		= "ID_LBOX_ENVS";
	label   	= "ASI environments:";
	list		= "";
	fixed_height	= true;
	height		= 8;
	allow_accept	= true;
}
msg_text  : text {
   	key   = "ID_MSG_ENVS";
	label = "";
	width = 20;
}
envsel_dialog : dialog {
	label = "Select environment:";
	: boxed_column {
		envs_listbox ;
		msg_text ;
	}
	ok_cancel ;
}
//================================================================
//
//	USERNAME PASSWORD DIALOG BOX
//
//================================================================
usern_dialog : dialog {
label = "User name and Password";
:boxed_column {
	:column {
		: edit_box {
			key		= "do-username";
			label		= "&User name:";
			edit_width	= 15;
		}
	}
	:column {
		: edit_box {
			key		= "do-password";
			label		= "&Password:";
			edit_width	= 15;
                        password_char = "*" ;    
		}
	msg_text ;
}}
ok_only ;
}
//================================================================
//
//	CONNECT DIALOG BOX
//
//================================================================
name1_txt : text {
	key		= "ID_TEXT_NAME1";
	value		= "";
	fixed_width	= true ;
	width		= 20 ;
}
msg1_txt : text {
	key		= "ID_TEXT_MSG1";
	value		= "";
	fixed_width	= true ;
	width		= 20 ;
}
name2_txt : text {
	key		= "ID_TEXT_NAME2";
	value		= "";
	fixed_width	= true ;
	width		= 20 ;
}
msg2_txt : text {
	key		= "ID_TEXT_MSG2";
	value		= "";
	fixed_width	= true ;
	width		= 20 ;
}
name3_txt : text {
	key		= "ID_TEXT_NAME3";
	value		= "";
	fixed_width	= true ;
	width		= 20 ;
}
msg3_txt : text {
	key		= "ID_TEXT_MSG3";
	value		= "";
	fixed_width	= true ;
	width		= 20 ;
}

conn_dialog : dialog {
label = "Report:";
:boxed_column {
   label = "Environment connected:" ;
   :row {
	name1_txt ;
	msg1_txt ;
   }
   :row {
	name2_txt ;
	msg2_txt ;
   }
   :row {
	name3_txt ;
	msg3_txt ;
   }
}
ok_only ;
}
//================================================================
//
//  SQL SYNTAX ERROR DIALOG BOX
//
//================================================================
errclose_button : cancel_button {
   key 		= "cancel";
   label	= "&CLOSE";
   fixed_width	= true;
   width	= 12;
}

close_row : row {
   alignment   = centered ;    
   : spacer { width = 10 ;}
   : errclose_button {is_default = true ;}
   : spacer { width = 10; }
}

errmsg_texts : concatenation {        
   children_alignment = left ;
   : text {
       label  = "Error List:  Error ";
   }
   : text {
       key    = "ID_TEXT_ERRNUM";
       width  = 7 ;   
   }
   : text {
       label  = " of    ";
   }
   : text {
       key    = "ID_TEXT_ERRTOTAL";
       width  = 7 ;   
   }
}

errlist : column {
   : list_box {
      key              = "ID_LBOX_SQLERR" ;    
      height           = 6 ;        
      width            = 65 ;
      fixed_width_font = true ;        
   }
   : slider {
      key         = "ID_SLDR_ERRMSG" ;    
      layout      = horizontal ;
      min_value   = 0;
      max_value   = 255;
   }
}

diaglist : column {
   : list_box {
       label            = "Diagnostic Parameters: ";
       key              = "ID_LBOX_ASIERR" ;
       tabs             = "30 35 40" ;
       tab_truncate     = true ;
       height           = 6 ;        
       width            = 65 ;
       fixed_width_font = true ;        
   }
   : slider {
       key         = "ID_SLDR_EXTEND" ;    
       layout      = horizontal ;
       min_value   = 0;
       max_value   = 255;
   }
}
//================================================================
//
//	SQL DIAGNOSTICS DIALOG BOX
//
//================================================================
errmsg_dialog : dialog {
    aspect_ratio = 0;
    label = "SQL Return codes" ;
    : column {
        children_fixed_height = true ;        
        : column {
	    errmsg_texts ;
	    errlist ;                        
	    diaglist ;            
        }
        close_row ;
    }    
}
//================================================================
//
//	MESSAGE DIALOG BOX
//
//================================================================
msg_dialog : dialog {
label = "ASILISP message:";
:boxed_row {
    : text {
	key		= "name1_msg";
	value		= "";
	fixed_width	= true ;
	width		= 30 ;
}}
ok_only ;
}

question_dialog : dialog {
label = "ASILISP question:";
:boxed_row {
    : text {
	key		= "name1_quest";
	value		= "";
	fixed_width	= true ;
	width		= 30 ;
}}
ok_cancel ;
}
//================================================================
//
//  SQL EDIT DIALOG BOX
//
//================================================================
open_cursor_button: retirement_button {
    label	= "&OpenCurs...";
    key		= "ID_OPEN_CURS";
    width	= 15;
}
prepare_button: retirement_button {
    label	= "&Prepare";
    key		= "ID_PREPARE";
    width	= 15;
}
dealloc_stm_button: retirement_button {
    label	= "&Dealloc";
    key		= "ID_DEALLOC";
    width	= 15;
}
execute_button: retirement_button {
    label	= "&Execute";
    key		= "ID_EXECUTE";
    width	= 15;
}
iexecute_button: retirement_button {
    label	= "&Iexecute";
    key		= "ID_IEXECUTE";
    width	= 15;
}
nexecute_button: retirement_button {
    label	= "&Nexecute";
    key		= "ID_NEXECUTE";
    width	= 15;
}
diag_button: retirement_button {
    label	= "Di&agn ...";
    key		= "ID_DIAG";
    width	= 15;
}
editexit_button : cancel_button {
    key 	= "ID_BUTT_EXIT";
    label	= "&CLOSE";
    fixed_width	= true;
    width	= 15;
}
curs_toggle : boxed_column {
    label = "Cursor type" ;
    : toggle {
    	key   = "ID_TOGGL_SCROLL";
    	label = "Scrollable";
    	value = 0;
}}

sql_statement : boxed_column {
   label = "SQL Statement";
   : edit_box {
         key            = "ID_EBOX_COND";       
         label          = "";
         alignment      = left ;
   }
   : popup_list {
         key            = "ID_POPUP_COND";       
         label          = "";
         alignment      = left ;
   }
   : text {
	key = "ID_TXT_SQLSTM" ;
        alignment      = left ;
   }
}

prepare_group : boxed_column {
   label = "Prepare group";
   alignement = left;
   prepare_button ;
   dealloc_stm_button ;
   open_cursor_button ;
}

execute_group : boxed_column {
   label = "Execute group";
   alignement = left;
   execute_button ;
   iexecute_button ;
   nexecute_button ;
}

free_group : boxed_column {
   label = "Control group";
   alignement = left;
   diag_button ;
   editexit_button ;
}

sqlstm_result : text {
	key = "ID_SQLSTM_RESULT" ;
        alignment      = left ;
}

sqled_dialog : dialog {
   label = "SQL Edit";
   : boxed_column {
   	sql_statement ;
	:row {
            curs_toggle ;
            prepare_group ;
            execute_group ;
            free_group ;
	}
	sqlstm_result ;
   }
}
//================================================================
//
//  CURSOR DIALOG BOX
//
//================================================================
next_button : retirement_button {
    label       = "&Next";
    key         = "ID_BUTT_NEXT";
    width       = 6 ;
}
prior_button : retirement_button {
    label       = "&Prior";
    key         = "ID_BUTT_PRIOR";
    width       = 6 ;
}
first_button : retirement_button {
    label       = "&First";
    key         = "ID_BUTT_FIRST";
    width       = 6 ;
}
last_button : retirement_button {
    label       = "&Last";
    key         = "ID_BUTT_LAST";
    width       = 6 ;
}
set_button: retirement_button {
    key 	= "ID_SET_CURS";
    label	= "&SET";
    fixed_width	= true;
    width	= 6 ;
}
update_button: retirement_button {
    key 	= "ID_UPDATE_CURS";
    label	= "&UPDATE";
    fixed_width	= true;
    width	= 12 ;
}
delete_button: retirement_button {
    key 	= "ID_DELETE_CURS";
    label	= "&DELETE";
    fixed_width	= true;
    width	= 12 ;
}
curs_diag_button: retirement_button {
    key 	= "ID_CURS_DIAG";
    label	= "D&IAGN...";
    fixed_width	= true;
    width	= 12 ;
}
close_button: cancel_button {
    key 	= "ID_CLOSE_CURS";
    label	= "&CLOSE";
    fixed_width	= true;
    width	= 12 ;
}

set_value_group : boxed_column {
label = "Set Cursor";
   : concatenation {
	   : text_part {
         	key   = "ID_NAME_UPD";       
		label = "name:";
		fixed_width	= true ;
		width		= 8 ;
	   }
	   : text_part {
         	key   = "ID_ARG_NAME";       
		label = "";
		alignment       = left ;
		fixed_width	= true ;
		width		= 36 ;
	   }
   }
   : row {
	   : edit_box {
	         alignment      = left ;
	         label          = "value:";
	         key            = "ID_EBOX_UPD";       
	   }
	   set_button ;
   }
}

operation_group : boxed_row {
   label = "Operations:";
   next_button ;
   prior_button ;
   first_button ;
   last_button ;
}

close_group : column {
   label = "";
   alignement = left;
   update_button ;
   delete_button ;
   curs_diag_button ;
   close_button ;
}

cursor_box : boxed_row {
   	label = "Current row:";
	alignment           = left ;
	children_fixed_width= true ;
	: list_box {
                 alignment      = left ;         
                 key            = "ID_LBOX_CURSOR";
                 height         = 6 ;
                 width          = 65 ;
                 fixed_width_font = true ;
                 tabs           = "20 25 30 35 60" ;
                 tab_truncate   = true ;
		 multiple_select= false ;
		 value		= "0" ;
        }
}

cursor_result : text {
	key = "ID_CURSOR_RESULT" ;
        alignment      = left ;
}

cursor_dialog : dialog {
label = "CURSOR";
: boxed_column {
	cursor_box ;
	set_value_group ;
	: row {
	   operation_group ;
	   close_group ;
	}
	cursor_result ;
}}

//================================================================
//
//  PARAMETERS LIST DIALOG BOX
//
//================================================================
setvalue_button: retirement_button {
    key 	= "ID_SET_VALUE";
    label	= "&SET";
    fixed_width	= true;
    width	= 6 ;
}
closepardial_button: cancel_button {
    key 	= "ID_CLOSE_PAR";
    label	= "&CLOSE";
    fixed_width	= true;
    width	= 12 ;
}

set_parvalue_group : boxed_column {
label = "Set parameter values";
   : concatenation {
	   : text_part {
         	key   = "ID_PAR_NAME";       
		label = "name:";
		fixed_width	= true ;
		width		= 8 ;
	   }
	   : text_part {
         	key   = "ID_PAR_VALUE";       
		label = "";
		alignment       = left ;
		fixed_width	= true ;
		width		= 8 ;
	   }
   }
   : row {
	   : edit_box {
	         alignment      = left ;
	         label          = "value:";
	         key            = "ID_EBOX_VALUE";       
	   }
	   setvalue_button ;
   }
}

closepar_group : column {
   label = "";
   alignement = left;
   closepardial_button ;
}

parlist_box : boxed_row {
   	label = "Parameters:";
	alignment           = left ;
	children_fixed_width= true ;
	: list_box {
                 alignment      = left ;         
                 key            = "ID_LBOX_PARS";
                 height         = 6 ;
                 width          = 65 ;
                 fixed_width_font = true ;
                 tabs           = "20 25 30 35 60" ;
                 tab_truncate   = true ;
		 multiple_select= false ;
		 value		= "0" ;
        }
}

parlist_dialog : dialog {
label = "PARAMETERS";
: column {
	parlist_box ;
	set_parvalue_group ;
	: row {
	   closepar_group ;
	}
}}

//================================================================
//
//  SINGLE ROW DIALOG BOX
//
//================================================================

single_row_dialog : dialog {
label = "SINGLE ROW";
: boxed_column {
   cursor_box ;
   close_button ;
}}
