;;;
; $Id: envsdlg.lsp,v 1.5 1995/12/20 03:49:55 kirila Exp $
;;;
;;;    envsdlg.lsp
;;;    
;;;    Copyright (C) 1995, 1996 by Autodesk, Inc.
;;;    
;;;    Permission to use, copy, modify, and distribute this software 
;;;    for any purpose and without fee is hereby granted, provided
;;;    that the above copyright notice appears in all copies and 
;;;    that both that copyright notice and the limited warranty and 
;;;    restricted rights notice below appear in all supporting 
;;;    documentation.
;;;    
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.  
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
;;;    UNINTERRUPTED OR ERROR FREE.
;;;    
;;;    Use, duplication, or disclosure by the U.S. Government is subject to 
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer 
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
;;;    (Rights in Technical Data and Computer Software), as applicable. 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	This file provide the dialog program for SQL ENVIRONMENT SELECTION
;;;
;;;

(defun envsel-dialog (envnames / index envm usern-passw retval)

   (if (not (new_dialog "envsel_dialog" DCL-ID))	; Initialize the dialog
	(exit))						; exit if this doesn't work

   (action_tile				; Associate an action expression with
	"ID_LBOX_ENVS"			; a key -- in this case, the OK button
	"(setq index (get_tile \"ID_LBOX_ENVS\"))" 
   )					; End the dialogue when OK is pressed

   (action_tile
	"cancel"
	"(setq retval 'CANCEL) (done_dialog)"
   )

   (start_list "ID_LBOX_ENVS")		; make environment names listbox
   (mapcar 'add_list envnames)
   (end_list)

   (if (null envnames)			; set message (number of environments)
       (set_tile "ID_MSG_ENVS" MSG_NO_ENVS_FOUND)
       (set_tile "ID_MSG_ENVS" (strcat (itoa (length envnames)) MSG_ENVS_FOUND))
   )

   (start_dialog)		; Display the dialog box

   (if (not (null index))	; if any environment is selected
      (progn
   	(setq envm (nth (atoi index) envnames))		; get selected environment
	(setq usern-passw (make-dial "userndlg" 'usern-dialog nil))	; get user name and password
        (setq retval (append (list envm) usern-passw))
      )
      (setq retval 'CANCEL) )
   retval
)
