;;;
; $Id: errmsdlg.lsp,v 1.5 1995/12/20 03:49:57 kirila Exp $
;;;
;;;    errmsgdlg.lsp
;;;    
;;;    Copyright (C) 1995, 1996 by Autodesk, Inc.
;;;    
;;;    Permission to use, copy, modify, and distribute this software 
;;;    for any purpose and without fee is hereby granted, provided
;;;    that the above copyright notice appears in all copies and 
;;;    that both that copyright notice and the limited warranty and 
;;;    restricted rights notice below appear in all supporting 
;;;    documentation.
;;;    
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.  
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
;;;    UNINTERRUPTED OR ERROR FREE.
;;;    
;;;    Use, duplication, or disclosure by the U.S. Government is subject to 
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer 
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
;;;    (Rights in Technical Data and Computer Software), as applicable. 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	This file provide the dialog program for display SQL ERROR messages 
;;;
;;;
(defun errmsg-dialog ()
  (if (not (new_dialog "errmsg_dialog" DCL-ID))	; Initialize dialog
    (exit))					

  (action_tile
    "cancel"
    "(done_dialog)"
  )

  (action_tile
    "ID_LBOX_SQLERR"
    "(update-errlist (atoi $value))"
  )

  (init-errmsg-dialog)
  (start_dialog)		; Display the dialogue box
)

(defun get-msgerrlist ( / sqlerr errdepth n)
  (setq n 1)
  (setq sqlerr (asi_diag 0 '("MESSAGE_TEXT")))
  (setq errdepth (asi_errqty))   
  (while (< n errdepth)
    (setq sqlerr (append sqlerr (asi_diag n '("MESSAGE_TEXT"))))
    (setq n (1+ n))
  )
  (mapcar '(lambda (l) (strcat "Error: " (cdr l))) sqlerr)
)

(defun get-errlist (depth)
  (cdr (mapcar '(lambda (l) (strcat (car l) "\t" (cdr l))) 
    (asi_diag depth)))
)

(defun update-errlist (errdepth / sqlerr)
  (setq sqlerr (get-errlist errdepth))
  (start_list "ID_LBOX_ASIERR")
  (mapcar 'add_list sqlerr)
  (end_list)
)

(defun init-errmsg-dialog ( / errdepth sqlerr)
  (setq errdepth (asi_errqty))   
  (set_tile "ID_TEXT_ERRNUM" "0")
  (set_tile "ID_TEXT_ERRTOTAL" (itoa errdepth))

  (if (> errdepth 0)
    (progn
      (setq sqlerr (get-msgerrlist))
      (start_list "ID_LBOX_SQLERR")
      (mapcar 'add_list sqlerr)
      (end_list)
      (update-errlist 0)   ))
)
