;;;
; $Id: parlist.lsp,v 1.5 1995/12/20 03:49:59 kirila Exp $
;;;
;;;    parlist.lsp
;;;    
;;;    Copyright (C) 1995, 1996 by Autodesk, Inc.
;;;    
;;;    Permission to use, copy, modify, and distribute this software 
;;;    for any purpose and without fee is hereby granted, provided
;;;    that the above copyright notice appears in all copies and 
;;;    that both that copyright notice and the limited warranty and 
;;;    restricted rights notice below appear in all supporting 
;;;    documentation.
;;;    
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.  
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
;;;    UNINTERRUPTED OR ERROR FREE.
;;;    
;;;    Use, duplication, or disclosure by the U.S. Government is subject to 
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer 
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
;;;    (Rights in Technical Data and Computer Software), as applicable. 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	This file provide dialog program for request parameters in SQL requests like
;;;		       "select * from GUESTS where NAME=:name and BUILD=:build"
;;;
;;;
(defun parlist-dialog (inparlist / curr-item-number)
   (if (not (new_dialog "parlist_dialog" DCL-ID))	; Initialize the dialog
	(exit))						

   (action_tile
	"ID_CLOSE_PAR"
	"(done_dialog)"
   )

   (setq curr-item-number 0)
   (action_tile
	"ID_SET_VALUE"
	"(setq inparlist (set-value inparlist curr-item-number))"
   )

   (action_tile
	"ID_LBOX_PARS"
	"(write-param-value inparlist (setq curr-item-number (atoi $value)))"
   )

   (init-parlist-dialog inparlist) 
   (start_dialog)		; Display the dialogue box

   (mapcar 'cdr inparlist)
)

(defun set-value (inparlist nvalue / name new_value str-cursor-list)
  (setq name (car (nth nvalue inparlist)))
  (setq new-value (get_tile "ID_EBOX_VALUE"))
  (setq inparlist (subst (cons name new-value) (nth nvalue inparlist) inparlist))
  (setq str-cursor-list (get-rowstring inparlist))
  (make-parlist-dialog str-cursor-list)
  inparlist
)

(defun write-param-value (inparlist nvalue / item)	; item = (name.value)
  (setq item (nth nvalue inparlist))
  (set_tile "ID_PAR_VALUE" (car item))
  (set_tile "ID_EBOX_VALUE" (cdr item))
)

(defun make-parlist-dialog (str-cursor-list)
  (start_list "ID_LBOX_PARS")
  (mapcar 'add_list str-cursor-list)
  (end_list)
)

(defun update-parlist-dialog (str-cursor-list)
  (start_list "ID_LBOX_PARS" 1)
  (mapcar 'add_list str-cursor-list)
  (end_list)
)

(defun get-rowstring (inparlist)
  (mapcar '(lambda (l) (strcat (car l) "\t" (cdr l))) inparlist)
)

(defun init-parlist-dialog (inparlist / str-cursor-list)
  (setq str-cursor-list (get-rowstring inparlist))
  (make-parlist-dialog str-cursor-list)
  (write-param-value inparlist 0)
)

