;;;
; $Id: sqleddlg.lsp,v 1.5 1995/12/20 03:50:01 kirila Exp $
;;;
;;;    sqleddlg.lsp
;;;    
;;;    Copyright (C) 1995, 1996 by Autodesk, Inc.
;;;    
;;;    Permission to use, copy, modify, and distribute this software 
;;;    for any purpose and without fee is hereby granted, provided
;;;    that the above copyright notice appears in all copies and 
;;;    that both that copyright notice and the limited warranty and 
;;;    restricted rights notice below appear in all supporting 
;;;    documentation.
;;;    
;;;    AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.  
;;;    AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
;;;    UNINTERRUPTED OR ERROR FREE.
;;;    
;;;    Use, duplication, or disclosure by the U.S. Government is subject to 
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer 
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
;;;    (Rights in Technical Data and Computer Software), as applicable. 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;	The main SQL manip. program (SQL EDIT dialog box)
;;;
(defun sqled-dialog (  / sqlexamples retval)
   (if (not (new_dialog "sqled_dialog" DCL-ID))	; Initialize dialog
	(exit))					; exit if this doesn't work

; radio buttons

   (action_tile
	"ID_TOGGL_SCROLL"
	"(if (= $value \"1\") (setq  CSRTYPE \"SCROLL\") (setq CSRTYPE \"NON_SCROLL\"))"
   )

   (action_tile
	"ID_PREPARE"
	"(prepare-stm) (setq sqlexamples (add-sqlexmpl sqlexamples))"
   )

   (action_tile
	"ID_OPEN_CURS"
	"(open-csr)"
   )

   (action_tile
	"ID_DEALLOC"
	"(dealloc-stm)"
   )

   (action_tile
	"ID_EXECUTE"
	"(execute)"
   )

   (action_tile
	"ID_IEXECUTE"
	"(iexecute) (setq sqlexamples (add-sqlexmpl sqlexamples))"
   )

   (action_tile
	"ID_NEXECUTE"
	"(nexecute) (setq sqlexamples (add-sqlexmpl sqlexamples))"
   )

   (action_tile
	"ID_DIAG"
	"(setq retval (make-dial \"errmsdlg\" 'errmsg-dialog nil))"
   )

   (action_tile
	"ID_BUTT_EXIT"
	"(exit-dialog) (setq retval 'CANCEL) (done_dialog)"
   )

   (action_tile
	"ID_POPUP_COND"
	"(set-sqlexmpl sqlexamples (atoi $value))"
   )

   (setq sqlexamples (init-sqlexamples-popup))
   (init-sqled-dialog)
   (start_dialog)		; Display the dialogue box

   retval
)

(defun init-sqlexamples-popup ( / sqlexamples)
  (setq sqlexamples '("CREATE TABLE SAMPLE (ZIP INTEGER, NAME CHAR(25), SEX CHAR(1), BIRTHDAY DATE)"
		      "INSERT INTO SAMPLE VALUES (124124,'MARCELLO HISTRIONI', 'M', DATE '1954-02-11')"
		      "INSERT INTO SAMPLE VALUES (746236,'JEAN-PAUL ROTUNDO',  'M', NULL)"
	              "INSERT INTO SAMPLE VALUES (551513,'BETTE MIDRIFF',      'F', DATE '1943-12-21')"
		      "INSERT INTO SAMPLE VALUES (462623,'JOANNIE RIVULETS',   'F', DATE '1967-04-14')"
		      "INSERT INTO SAMPLE VALUES (763634,'WARREN AMOROSO',     'M', NULL)"
		      "INSERT INTO SAMPLE VALUES (573734,'MARLON SPANDEX',     'M', DATE '1974-05-12')"
		      "INSERT INTO SAMPLE VALUES (436346,'OLYMPIA WELCH',      'F', DATE '1937-07-21')"
		      "SELECT * FROM SAMPLE"
		      "SELECT * FROM SAMPLE ORDER BY NAME"
		      "SELECT TRIM('HAPPY BIRTHDAY! DEAR ' || NAME) || '!' FROM SAMPLE WHERE EXTRACT(DAY FROM BIRTHDAY)=21"
		      "INSERT INTO SAMPLE VALUES(:ZIP, :NAME, :SEX, :BIRTHDAY)"
		      "SELECT NAME, BIRTHDAY FROM SAMPLE WHERE SEX = :SEX AND BIRTHDAY IS NULL"
		      "UPDATE SAMPLE SET BIRTHDAY = CURRENT_DATE WHERE BIRTHDAY IS NULL"
		      "SELECT COUNT (*) FROM SAMPLE WHERE SEX='M'"
                      "DELETE FROM SAMPLE WHERE ZIP >= 700000"
                      "SELECT CASE SEX WHEN 'F' THEN 'WOMAN' WHEN 'M' THEN 'MAN' END,MAX(ZIP),MIN(ZIP),COUNT(ZIP) FROM SAMPLE GROUP BY SEX"
                      "SELECT NAME, BIRTHDAY, SEX INTO :NAME, :BIRTHDAY, :SEX FROM SAMPLE WHERE ZIP = 551513"
		      "PACK ASE.DB3SAMPLE.SAMPLE"
                      "DROP TABLE SAMPLE RESTRICT"
 		      ""))

  (start_list "ID_POPUP_COND")
  (mapcar 'add_list sqlexamples)
  (end_list)
  sqlexamples
)

(defun add-to-list (newex sqlexamples)
  (setq sqlexamples (append sqlexamples (list newex)))
  (if (>= (length sqlexamples) 40)
    (setq sqlexamples (cdr sqlexamples)))
  (start_list "ID_POPUP_COND" 3)
  (mapcar 'add_list sqlexamples)
  (end_list)
  sqlexamples
)
;;
;;	add new SQL example, writed by user, to examples list 
;;
(defun add-sqlexmpl (sqlexamples / newex)
  (if (/= (setq newex (get_tile "ID_EBOX_COND")) "")
    (setq sqlexamples (add-to-list newex sqlexamples)) )
  sqlexamples
)
;;
;;	sett SQL example from examples list to EDIT box
;;
(defun set-sqlexmpl (sqlexamples index / item)
   (setq item (nth index sqlexamples))
   (set_tile "ID_EBOX_COND" item)
)
;;
;;	set state of buttons when sqledit dialog start
;;
(defun init-sqled-dialog ()
  (mode_tile "ID_RBUT_RDONL" 	1)
  (mode_tile "ID_RBUT_SCROL" 	1)
  (mode_tile "ID_RBUT_UPD" 	1)
  (mode_tile "ID_PREPARE" 	0)
  (mode_tile "ID_OPEN_CURS" 	1)
  (mode_tile "ID_DEALLOC" 	1)
  (mode_tile "ID_EXECUTE" 	1)
  (mode_tile "ID_IEXECUTE" 	0)
  (mode_tile "ID_NEXECUTE" 	0)
  (mode_tile "ID_DIAG" 		0)
  (mode_tile "ID_BUTT_EXIT" 	0)
  (setq CSRTYPE "NON_SCROLL") 
)
;;
;;	set state of buttons when statement is prepared
;;
(defun init-stm-prepared ()
  (mode_tile "ID_PREPARE"  1)
  (mode_tile "ID_DEALLOC"  0)
  (mode_tile "ID_EXECUTE"  0)
  (mode_tile "ID_IEXECUTE" 0)
  (mode_tile "ID_NEXECUTE" 0)
)
;;
;;	set state of buttons when statement is deallocated
;;
(defun init-stm-noprepared ()
  (mode_tile "ID_DEALLOC"  1)
  (mode_tile "ID_EXECUTE"  1)
  (mode_tile "ID_PREPARE"  0)
  (init-stm-noselect)
)
;;
;;	set state of buttons when prepared statement of type CURSOR
;;
(defun init-stm-select ()
   (mode_tile "ID_OPEN_CURS" 	0)
   (mode_tile "ID_RBUT_RDONL" 	0)
   (mode_tile "ID_RBUT_SCROL" 	0)
   (mode_tile "ID_RBUT_UPD" 	0)
)
;;
;;	set state of buttons when prepared statement of the no CURSOR type
;;
(defun init-stm-noselect ()
   (mode_tile "ID_OPEN_CURS" 	1)
   (mode_tile "ID_RBUT_RDONL" 	1)
   (mode_tile "ID_RBUT_SCROL" 	1)
   (mode_tile "ID_RBUT_UPD" 	1)
)
;;
;;	defun return cursor type
;;
(defun cursor-type ()
  CSRTYPE
)

(defun csr-openp (csr)
  (= (logand (asi_statecsr csr) 2) 2)
)

(defun curs-name ()	; generate new cursor name
  (if (/= (type CURS-NAME-NUMBER) 'INT)		; init if was absent
    (setq CURS-NAME-NUMBER 0))
  (setq CURS-NAME-NUMBER (1+ CURS-NAME-NUMBER))
  (strcat "CURS-NAME" (itoa CURS-NAME-NUMBER))
)

(defun csr-alloc (stmt)
  (setq CURSOR (asi_alloc stmt (curs-name) (cursor-type)))
)

(defun input-parameters-list (obj-dsc / parlist retval inparlist)
  (if (setq parlist (asi_pardsc obj-dsc))
    (progn
      (setq inparlist (mapcar '(lambda (e1) (cons (cdar e1) ""))  parlist)) 
      (setq retval (make-dial "parlist" 'parlist-dialog (list inparlist)))
    )
  )  
)

(defun open-csr ()
  (set_tile "ID_SQLSTM_RESULT" "")	; init SQL statement string
  (if (csr-alloc STATEMENT)
    (if (csr-openp CURSOR)
      (set_tile "ID_SQLSTM_RESULT" MSG_CLOSE_CURS_FIRST)
      (if (asi_open CURSOR (input-parameters-list CURSOR)) 
        (make-dial "cursdlg" 'cursor-dialog nil)
        (set_tile "ID_SQLSTM_RESULT" MSG_CANT_OPEN_CURS)
      )
    )
    (set_tile "ID_SQLSTM_RESULT" MSG_CLOSE_CURS_FIRST)
  )
)

(defun doprepare ()
  (if (setq STATEMENT (asi_prepare SESSION sql-statement))
    (progn		; STATEMENT is prepared
      (init-stm-prepared)
      (if (= (setq stmtype (asi_stmtype STATEMENT)) "CURSOR")	; if type of sql mess. is select
	(init-stm-select) 
	(init-stm-noselect)
      )
      (set_tile "ID_TXT_SQLSTM"  (strcat MSG_TYPE_SQLSTM_IS stmtype) )
      (set_tile "ID_SQLSTM_RESULT" MSG_SQLSTM_IS_PREPARED)
    )
    (progn		; STATEMENT is no prepared
      (set_tile "ID_SQLSTM_RESULT" MSG_ERROR_PREPARING)
      (set_tile "ID_TXT_SQLSTM" "") 
      (init-stm-noprepared)
    )
  )	; end if
)

(defun prepare-stm ( / sql-statement stmtype)
  (setq sql-statement (get_tile "ID_EBOX_COND"))
  (if (null (asi_objp STATEMENT))
    (if (/= sql-statement "")	; SQL statement is empty?
      (doprepare)
      (progn			; STATEMENT is empty
        (set_tile "ID_SQLSTM_RESULT" MSG_SQLSTM_ISEMPTY)
        (init-stm-noprepared)	; Hide buttons
      )
    )
    (set_tile "ID_SQLSTM_RESULT" MSG_QUEST_DEALLOC_STM)
  )  ; end if
)

(defun close-cursor ()
  (if (asi_objp CURSOR)
    (asi_close CURSOR))
)

(defun dealloc-stm ()
  (close-cursor)
  (if (asi_deallocstm STATEMENT)
    (progn
      (init-stm-noprepared)
      (set_tile "ID_SQLSTM_RESULT" MSG_SQLSTM_ISDEALLOC) 
    )  
    (set_tile "ID_SQLSTM_RESULT" MSG_ERROR_DEALLOC) 
  )
  (set_tile "ID_TXT_SQLSTM" "") 
)

(defun iexecute ( / sql-statement)
  (setq sql-statement (get_tile "ID_EBOX_COND"))
  (if (/= sql-statement "")
    (if (asi_iexecute SESSION sql-statement)
      (msg-rowqty SESSION MSG_SQLSTM_IS_EXECUTED)
      (set_tile "ID_SQLSTM_RESULT" MSG_ERROR_IEXECUTE)
    )
    (progn		; STATEMENT is empty
      (set_tile "ID_SQLSTM_RESULT" MSG_SQLSTM_ISEMPTY)
      (init-stm-noprepared)
    )
  )
)

(defun nexecute ( / native-statement)
  (setq native-statement (get_tile "ID_EBOX_COND"))
  (if (/= native-statement "")
    (if (asi_nexecute SESSION native-statement)
      (set_tile "ID_SQLSTM_RESULT" MSG_STM_ISEXECUTED)
      (set_tile "ID_SQLSTM_RESULT" MSG_ERROR_NEXECUTE)
    )
    (progn		; STATEMENT is empty
      (set_tile "ID_SQLSTM_RESULT" MSG_STM_ISEMPTY)
      (init-stm-noprepared)
    )
  )
;  (add-sqlexmpl)
)

(defun msg-rowqty (asi-obj str / stmtype nrows) 
  (setq stmtype (asi_stmtype asi-obj))
  (if (or (= stmtype "INSERT") 
          (= stmtype "UPDATE_WHERE")
          (= stmtype "DELETE_WHERE"))
    (progn
      (setq nrows (asi_rowqty asi-obj))
      (set_tile "ID_SQLSTM_RESULT" (strcat str MSG_NUMBER_ROWS_AFFECTED (rtos nrows)))
    )
    (set_tile "ID_SQLSTM_RESULT" str)
  )
)

(defun single-row-select-stm (rowlist)
  (make-dial "cursdlg" 'singlerow-dialog (list rowlist))
)

(defun execute ( / result)
;(setq result (asi_execute STATEMENT (input-parameters-list STATEMENT)))
;(print result)
;(print (asi_errqty))

  (if (asi_objp STATEMENT)	; statement is active?
    (if (setq result (asi_execute STATEMENT (input-parameters-list STATEMENT)))
      (if (= (asi_stmtype STATEMENT) "SELECT")	; then is SINGLE ROW SELECT STATEMENT
         (single-row-select-stm result)
         (msg-rowqty STATEMENT MSG_SQLSTM_IS_EXECUTED) ; 
      )
      (set_tile "ID_SQLSTM_RESULT" MSG_ERROR_EXECUTE)
    )
    (progn		; STATEMENT is empty
      (set_tile "ID_SQLSTM_RESULT" MSG_SQLSTM_IS_NOTPREPARED)
      (init-stm-noprepared)
    )
  )
)

(defun exit-dialog ()
  (if (asi_objp STATEMENT)
    (dealloc-stm))
)